/*
* Creates a complex with a facet from the colors on Processes and empty view.
*/
complex_by_processes(ProcessesAndViews,Complex):-
    vertices(ProcessesAndViews,Vertices),
    oset_power(Vertices,Complex).

vertices([],[]):-!.

vertices([Proc => View|MoreProcsAndViews],[v(Proc,View)|MoreVertices]):-
    vertices(MoreProcsAndViews,MoreVertices).

complex_muddy(
    [
        %Empty simplex
        [],
	    % All vertices
        %0
	    [v(a,['_',0,0])],
        %1
        [v(a,['_',0,1])],
        %2
        [v(a,['_',1,0])],
        %3
        [v(a,['_',1,1])],
        %4
	    [v(b,[0,'_',0])],
        %5
        [v(b,[0,'_',1])],
        %6
        [v(b,[1,'_',0])],
        %7
        [v(b,[1,'_',1])],
        %8
	    [v(c,[0,0,'_'])],
        %9
        [v(c,[0,1,'_'])],
        %10
        [v(c,[1,0,'_'])],
        %11
        [v(c,[1,1,'_'])],
	    % For each 2-simplex we have 3 1-simplices
        %000
	    [v(a,['_',0,0]),v(b,[0,'_',0])],
        [v(a,['_',0,0]),v(c,[0,0,'_'])],
        [v(b,[0,'_',0]),v(c,[0,0,'_'])],
        [v(a,['_',0,0]),v(b,[0,'_',0]),v(c,[0,0,'_'])],
        %001
	    [v(a,['_',0,1]),v(b,[0,'_',1])],
        [v(a,['_',0,1]),v(c,[0,0,'_'])],
        [v(b,[0,'_',1]),v(c,[0,0,'_'])],
        [v(a,['_',0,1]),v(b,[0,'_',1]),v(c,[0,0,'_'])],
        %010
	    [v(a,['_',1,0]),v(b,[0,'_',0])],
        [v(a,['_',1,0]),v(c,[0,1,'_'])],
        [v(b,[0,'_',0]),v(c,[0,1,'_'])],
        [v(a,['_',1,0]),v(b,[0,'_',0]),v(c,[0,1,'_'])],
        %011
	    [v(a,['_',1,1]),v(b,[0,'_',1])],
        [v(a,['_',1,1]),v(c,[0,1,'_'])],
        [v(b,[0,'_',1]),v(c,[0,1,'_'])],
        [v(a,['_',1,1]),v(b,[0,'_',1]),v(c,[0,1,'_'])],
        %100
	    [v(a,['_',0,0]),v(b,[1,'_',0])],
        [v(a,['_',0,0]),v(c,[1,0,'_'])],
        [v(b,[1,'_',0]),v(c,[1,0,'_'])],
        [v(a,['_',0,0]),v(b,[1,'_',0]),v(c,[1,0,'_'])],
        %101
	    [v(a,['_',0,1]),v(b,[1,'_',1])],
        [v(a,['_',0,1]),v(c,[1,0,'_'])],
        [v(b,[1,'_',1]),v(c,[1,0,'_'])],
        [v(a,['_',0,1]),v(b,[1,'_',1]),v(c,[1,0,'_'])],
        %110
	    [v(a,['_',1,0]),v(b,[1,'_',0])],
        [v(a,['_',1,0]),v(c,[1,1,'_'])],
        [v(b,[1,'_',0]),v(c,[1,1,'_'])],
        [v(a,['_',1,0]),v(b,[1,'_',0]),v(c,[1,1,'_'])],
        %111
	    [v(a,['_',1,1]),v(b,[1,'_',1])],
        [v(a,['_',1,1]),v(c,[1,1,'_'])],
        [v(b,[1,'_',1]),v(c,[1,1,'_'])],
        [v(a,['_',1,1]),v(b,[1,'_',1]),v(c,[1,1,'_'])]
    ]
).

complex_muddy_incomplete(
    [
	    % All vertices
        %0
	    [v(a,[1,0,0])],
        %1
        [v(a,['_',0,1])],
        %2
        [v(a,['_',1,0])],
        %3
        [v(a,['_',1,1])],
        %4
	    [v(b,[0,1,0])],
        %5
        [v(b,[0,'_',1])],
        %6
        [v(b,[1,'_',0])],
        %7
        [v(b,[1,'_',1])],
        %8
	    [v(c,[0,0,1])],
        %9
        [v(c,[0,1,'_'])],
        %10
        [v(c,[1,0,'_'])],
        %11
        [v(c,[1,1,'_'])],
	    % For each 2-simplex we have 3 1-simplices
        %000
	    /*[v(a,['_',0,0]),v(b,[0,'_',0])],
        [v(a,['_',0,0]),v(c,[0,0,'_'])],
        [v(b,[0,'_',0]),v(c,[0,0,'_'])],
        [v(a,['_',0,0]),v(b,[0,'_',0]),v(c,[0,0,'_'])],*/
        %001
	    [v(a,['_',0,1]),v(b,[0,'_',1])],
        [v(a,['_',0,1]),v(c,[0,0,1])],
        [v(b,[0,'_',1]),v(c,[0,0,1])],
        [v(a,['_',0,1]),v(b,[0,'_',1]),v(c,[0,0,1])],
        %010
	    [v(a,['_',1,0]),v(b,[0,1,0])],
        [v(a,['_',1,0]),v(c,[0,1,'_'])],
        [v(b,[0,1,0]),v(c,[0,1,'_'])],
        [v(a,['_',1,0]),v(b,[0,1,0]),v(c,[0,1,'_'])],
        %011
	    [v(a,['_',1,1]),v(b,[0,'_',1])],
        [v(a,['_',1,1]),v(c,[0,1,'_'])],
        [v(b,[0,'_',1]),v(c,[0,1,'_'])],
        [v(a,['_',1,1]),v(b,[0,'_',1]),v(c,[0,1,'_'])],
        %100
	    [v(a,[1,0,0]),v(b,[1,'_',0])],
        [v(a,[1,0,0]),v(c,[1,0,'_'])],
        [v(b,[1,'_',0]),v(c,[1,0,'_'])],
        [v(a,[1,0,0]),v(b,[1,'_',0]),v(c,[1,0,'_'])],
        %101
	    [v(a,['_',0,1]),v(b,[1,'_',1])],
        [v(a,['_',0,1]),v(c,[1,0,'_'])],
        [v(b,[1,'_',1]),v(c,[1,0,'_'])],
        [v(a,['_',0,1]),v(b,[1,'_',1]),v(c,[1,0,'_'])],
        %110
	    [v(a,['_',1,0]),v(b,[1,'_',0])],
        [v(a,['_',1,0]),v(c,[1,1,'_'])],
        [v(b,[1,'_',0]),v(c,[1,1,'_'])],
        [v(a,['_',1,0]),v(b,[1,'_',0]),v(c,[1,1,'_'])],
        %111
	    [v(a,['_',1,1]),v(b,[1,'_',1])],
        [v(a,['_',1,1]),v(c,[1,1,'_'])],
        [v(b,[1,'_',1]),v(c,[1,1,'_'])],
        [v(a,['_',1,1]),v(b,[1,'_',1]),v(c,[1,1,'_'])]
    ]
).

complex_attack1_0(
[
    [v(black,['_'])],
    [v(white,[0])],
    [v(white,[1])],
    [v(black,['_']),v(white,[0])],
    [v(black,['_']),v(white,[1])]
]
).

complex_attack1_1(
[
    [v(black,[0])],
    [v(black,['_'])],
    [v(black,[1])],
    [v(white,[0])],
    [v(white,[1])],
    [v(black,[0]),v(white,[0])],
    [v(black,['_']),v(white,[0])],
    [v(black,[1]),v(white,[1])],
    [v(black,['_']),v(white,[1])]
]
).

complex_attack2(
[
    [v(black,[0,'_'])],
    [v(black,['_',0])],
    [v(black,[1,'_'])],
    [v(white,[0,1])],
    [v(white,[0,0])],
    [v(white,[1,0])],
    [v(white,[1,1])],
    [v(white,[0,1]),v(black,[0,'_'])],
    [v(black,[0,'_']),v(white,[0,0])],
    [v(white,[0,0]),v(black,['_',0])],
    [v(black,['_',0]),v(white,[1,0])],
    [v(white,[1,0]),v(black,[1,'_'])],
    [v(black,[1,'_']),v(white,[1,1])]
]
).

complex_attack2_4_0(
[
    [v(b,[0,'_'])],
    [v(b,[1,'_'])],
    [v(w,['_',0])],
    [v(w,['_',1])],
    [v(b,[0,'_']),v(w,['_',0])],
    [v(b,[0,'_']),v(w,['_',1])],
    [v(b,[1,'_']),v(w,['_',0])],
    [v(b,[1,'_']),v(w,['_',1])]
]


).



complex_attack2_4_1(
[
    [v(b,['_',0,'_'])],
    [v(b,['_',1,'_'])],
    [v(w,[1,0,1])],
    [v(w,[0,'_',0])],
    [v(w,[0,0,1])],
    [v(w,[1,1,1])],
    [v(w,[1,'_',0])],
    [v(w,[0,1,1])],
    [v(b,['_',0,'_']),v(w,[1,0,1])],
    [v(b,['_',0,'_']),v(w,[0,'_',0])],
    [v(b,['_',0,'_']),v(w,[0,0,1])],
    [v(b,['_',0,'_']),v(w,[1,'_',0])],
    [v(b,['_',1,'_']),v(w,[0,'_',0])],
    [v(b,['_',1,'_']),v(w,[1,1,1])],
    [v(b,['_',1,'_']),v(w,[1,'_',0])],
    [v(b,['_',1,'_']),v(w,[0,1,1])]
]
).

complex_attack2_4_2(
[
    [v(b,[1,0,1,1])],
    [v(b,['_',0,'_',0])],
    [v(b,[0,0,1,1])],
    [v(b,[1,1,1,1])],
    [v(b,['_',1,'_',0])],
    [v(b,[0,1,1,1])],
    [v(w,[1,0,1,'_'])],
    [v(w,[0,'_',0,0])],
    [v(w,[0,0,1,'_'])],
    [v(w,[1,1,1,'_'])],
    [v(w,[1,'_',0,0])],
    [v(w,[0,1,1,'_'])],
    [v(w,[1,0,1,'_']),v(b,[1,0,1,1])],
    [v(w,[1,0,1,'_']),v(b,['_',0,'_',0])],
    [v(w,[0,'_',0,0]),v(b,['_',0,'_',0])],
    [v(w,[0,'_',0,0]),v(b,['_',1,'_',0])],
    [v(w,[0,0,1,'_']),v(b,['_',0,'_',0])],
    [v(w,[0,0,1,'_']),v(b,[0,0,1,1])],
    [v(w,[1,1,1,'_']),v(b,[1,1,1,1])],
    [v(w,[1,1,1,'_']),v(b,['_',1,'_',0])],
    [v(w,[1,'_',0,0]),v(b,['_',0,'_',0])],
    [v(w,[1,'_',0,0]),v(b,['_',1,'_',0])],
    [v(w,[0,1,1,'_']),v(b,['_',1,'_',0])],
    [v(w,[0,1,1,'_']),v(b,[0,1,1,1])]
]
).

complex_attack2_4_3(
[
    [v(b,[1,0,1,1,'_'])],
    [v(b,['_',0,'_',0,0])],
    [v(b,[0,0,1,1,'_'])],
    [v(b,[1,1,1,1,'_'])],
    [v(b,['_',1,'_',0,0])],
    [v(b,[0,1,1,1,'_'])],

    [v(w,[1,0,1,1,1])],
    [v(w,[1,0,1,'_',0])],
    [v(w,[0,'_',0,0,0])],
    [v(w,[0,0,1,'_',0])],
    [v(w,[0,0,1,1,1])],
    [v(w,[1,1,1,1,1])],
    [v(w,[1,1,1,'_',0])],
    [v(w,[1,'_',0,0,0])],
    [v(w,[0,1,1,'_',0])],
    [v(w,[0,1,1,1,1])],

    [v(w,[1,0,1,1,1]),v(b,[1,0,1,1,'_'])],
    [v(w,[1,0,1,'_',0]),v(b,[1,0,1,1,'_'])],

    [v(w,[1,0,1,'_',0]),v(b,['_',0,'_',0,0])],

    [v(w,[0,'_',0,0,0]),v(b,['_',0,'_',0,0])],
    [v(w,[0,'_',0,0,0]),v(b,['_',1,'_',0,0])],
    [v(w,[1,1,1,'_',0]),v(b,['_',1,'_',0,0])],
    [v(w,[1,1,1,'_',0]),v(b,[1,1,1,1,'_'])],
    [v(w,[1,1,1,1,1]),v(b,[1,1,1,1,'_'])],

    [v(w,[0,0,1,'_',0]),v(b,['_',0,'_',0,0])],
    [v(w,[0,0,1,'_',0]),v(b,[0,0,1,1,'_'])],
    [v(w,[0,0,1,1,1]),v(b,[0,0,1,1,'_'])],

    [v(w,[1,'_',0,0,0]),v(b,['_',0,'_',0,0])],
    [v(w,[1,'_',0,0,0]),v(b,['_',1,'_',0,0])],
    [v(w,[0,1,1,'_',0]),v(b,['_',1,'_',0,0])],
    [v(w,[0,1,1,'_',0]),v(b,[0,1,1,1,'_'])],
    [v(w,[0,1,1,1,1]),v(b,[0,1,1,1,'_'])]
]
).

complex_attack2_4_4(
[
    [v(b,[1,0,1,1,1,1])],
    [v(b,[1,1,1,1,1,1])],
    [v(b,[0,1,1,1,1,1])],
    [v(b,[0,0,1,1,1,1])],

    [v(b,[1,0,1,1,'_',0])],
    [v(b,['_',0,'_',0,0,0])],
    [v(b,[0,0,1,1,'_',0])],
    [v(b,[1,1,1,1,'_',0])],
    [v(b,['_',1,'_',0,0,0])],
    [v(b,[0,1,1,1,'_',0])],

    [v(w,[1,0,1,1,1,'_'])],
    [v(w,[1,0,1,'_',0,0])],
    [v(w,[0,'_',0,0,0,0])],
    [v(w,[0,0,1,'_',0,0])],
    [v(w,[0,0,1,1,1,'_'])],
    [v(w,[1,1,1,1,1,'_'])],
    [v(w,[1,1,1,'_',0,0])],
    [v(w,[1,'_',0,0,0,0])],
    [v(w,[0,1,1,'_',0,0])],
    [v(w,[0,1,1,1,1,'_'])],

    [v(w,[1,0,1,1,1,'_']),v(b,[1,0,1,1,'_',0])],
    [v(w,[1,0,1,'_',0,0]),v(b,[1,0,1,1,'_',0])],

    [v(w,[1,0,1,'_',0,0]),v(b,['_',0,'_',0,0,0])],

    [v(w,[0,'_',0,0,0,0]),v(b,['_',0,'_',0,0,0])],
    [v(w,[0,'_',0,0,0,0]),v(b,['_',1,'_',0,0,0])],
    [v(w,[1,1,1,'_',0,0]),v(b,['_',1,'_',0,0,0])],
    [v(w,[1,1,1,'_',0,0]),v(b,[1,1,1,1,'_',0])],
    [v(w,[1,1,1,1,1,'_']),v(b,[1,1,1,1,'_',0])],

    [v(w,[0,0,1,'_',0,0]),v(b,['_',0,'_',0,0,0])],
    [v(w,[0,0,1,'_',0,0]),v(b,[0,0,1,1,'_',0])],
    [v(w,[0,0,1,1,1,'_']),v(b,[0,0,1,1,'_',0])],

    [v(w,[1,'_',0,0,0,0]),v(b,['_',0,'_',0,0,0])],
    [v(w,[1,'_',0,0,0,0]),v(b,['_',1,'_',0,0,0])],
    [v(w,[0,1,1,'_',0,0]),v(b,['_',1,'_',0,0,0])],
    [v(w,[0,1,1,'_',0,0]),v(b,[0,1,1,1,'_',0])],
    [v(w,[0,1,1,1,1,'_']),v(b,[0,1,1,1,'_',0])],

    [v(w,[1,0,1,1,1,'_']),v(b,[1,0,1,1,1,1])],
    [v(w,[0,0,1,1,1,'_']),v(b,[0,0,1,1,1,1])],
    [v(w,[1,1,1,1,1,'_']),v(b,[1,1,1,1,1,1])],
    [v(w,[0,1,1,1,1,'_']),v(b,[0,1,1,1,1,1])]
]
).
