/*
* model_proy(model(Worlds,Edges),AgentsWithPosition,NewModel)
*/

model_proy(model(Worlds,Edges),AgentsWithPoition,NewModel):-
    agents_from_edges(Edges,Agents),
    length(Agents,NumberOfAgents),
    findall(Pos,member(_=>Pos,AgentsWithPoition),Poss_),
    list_to_set(Poss_,Poss),
    findall(Agent,member(Agent=>_,AgentsWithPoition),AgentsToPreserve_),
    list_to_set(AgentsToPreserve_,AgentsToPreserve),
    relabel_worlds(Worlds,NumberOfAgents,Poss,NewWorlds),
    relabel_edges(Edges,AgentsToPreserve,NewEdges),
    minimize(model(NewWorlds,NewEdges),NewModel).
    
/*
* relabel_worlds(Worlds,NumberOfAgents,Poss,NewWorlds)
* Relabel Worlds keeping the information on positions of the labeling modulo NumberOfAgents
* contained in Poss and changing to '_' in the remaining 
*/

relabel_worlds([],_,_,[]):-!.
    
relabel_worlds([w(Id,Label)|MoreWorlds],NumberOfAgents,Poss,[w(Id,NewLabel)|MoreNewWorlds]):-
    generate_new_label(Label,NumberOfAgents,Poss,0,NewLabel),
    relabel_worlds(MoreWorlds,NumberOfAgents,Poss,MoreNewWorlds).
    
/*
* Just call generate_new_view
* The algorithm is the same
*/

generate_new_label(Label,OldNumberOfAgents,Poss,0,NewLabel):-
    generate_new_view(Label,OldNumberOfAgents,Poss,0,NewLabel).
    
/*
*
*/
relabel_edges(Edges,AgentsToPreserve,NewEdges):-
    findall(
        edge(Src,NewLabel,Tgt),
        (
            member(edge(Tgt,Label,Src),Edges),
            intersection(Label,AgentsToPreserve,NewLabel),
            dif(NewLabel,[]) 
        ),
        NewEdges).

