/*
*
*/
ith([],_,_):-!,fail.

ith([X|_],0,X):-!.

ith([_|More],N,X):-
    N > 0,
    N2 is N - 1,
    ith(More,N2,X).

/*
* replace_ith(OldList,I,New,NewList)
* Replaces the Ith member with New
*/

replace_ith([],_,_,[]):-!.
replace_ith([_|Rest],0,New,[New|Rest]):-!.
replace_ith([X|Rest],N,New,[X|RestRep]):-
    N > 0,
    N2 is N - 1,
    replace_ith(Rest,N2,New,RestRep).

/*
* replace(CurrentList,CurrentElement,NewElement,NewList)
* True if NewList unifies with CurrentList replacing all CurrentElement with NewElement
*/
replace([],_,_,[]):-!.
replace([X|Rest],X,Y,[Y|ReplacedRest]):-
	!,
	replace(Rest,X,Y,ReplacedRest).
replace([W|Rest],X,Y,[W|ReplacedRest]):-
	!,
	replace(Rest,X,Y,ReplacedRest).

/*
* Check for set equality.
*/
set_equal(A,B):-
    contains(A,B),
    contains(B,A).

/*
* contains(A,B)
* True if A contais B
*/
contains([],[]):-!.
contains([X|More],Other):-
    delete(Other,X,NewOther),
    contains(More,NewOther).
    

/* imprime(Lista)
 * Imprime Lista un elemento por linea
 */
imprime([]).
imprime([H|T]) :- write(H), nl, imprime(T).

/*
* facets_to_complex(Facets,Complex)
* Builds a complex from a list of facets.
*/

facets_to_complex([],[]):-!.
    
facets_to_complex([Facet|MoreFacets],Complex):-
    facets_to_complex(MoreFacets,SubComplex1),
    oset_power(Facet,SubComplex2),
    union(SubComplex1,SubComplex2,Complex_),
    delete(Complex_,[],Complex).
    
/*
* agents_from_edges(Edges,Agents)
* Agents labeling Edges
*/

agents_from_edges(Edges,Agents):-
    findall(Agent,(member(edge(_,Label,_),Edges),member(Agent,Label)),Agents_),
    list_to_set(Agents_,Agents).
    
unionall([Set],Set):-!.

unionall([Set|MoreSets],Union):-
    unionall(MoreSets,MoreSetsUnion),
    union(Set,MoreSetsUnion,Union).
    
